import numpy as np

k1 = 100.
k1Ex = 100.
k2 = 100.
k2Ex = 100.
gammaH = 0.5
gammaG = 0.5
gEffg = 2.
gEffh = 2.
Gg1 = np.sqrt(k1 * gEffg / 8.0)
Gg2 = np.sqrt(k2 * gEffg / 8.0)
Gh1 = np.sqrt(k1 * gEffh / 8.0)
Gh2 = np.sqrt(k2 * gEffh / 8.0)
delta = 0.5

p = -2*np.arctan(gammaH/(2.*delta))

def S12(w, p=p, onlyone=None):
    w = w*0.5
    if onlyone == 'r':
        g1=0
        g2=0
        h1=Gh1
        h2=Gh2
    elif onlyone == 'l':
        h1=0
        h2=0
        g1=Gg1
        g2=Gg2
    else: 
        g1=Gg1
        g2=Gg2
        h1=Gh1
        h2=Gh2
    A = np.sqrt(k1Ex) * np.sqrt(k2Ex) * (
            1j * delta * np.exp(-1j*p) * g1 * g2
            + 0.5 * np.exp(-1j*p) * g1 * g2 * gammaH
            - 1j * delta * h1 * h2
            + 0.5 * gammaG * h1 * h2
            - 1j * np.exp(-1j*p) * g1 * g2 * w
            - 1j * h1 * h2 * w
            )
    B = 1j * h1 * (
            - 1j * g2**2 * h1
            + 1j * np.exp(-1j*p) * g1*g2*h2
            - 0.5 * delta * h1 * k2
            - 0.25 * 1j * gammaG * h1 * k2
            + 1j * delta * h1 * w
            - 0.5 * gammaG * h1 * w
            - 0.5 * h1 * k2 * w
            + 1j * h1 * w**2
            )
    C = -1j * h2 * (
            - 1j * np.exp(1j*p) * g1 * g2 * h1
            + 1j * g1**2 * h2
            + 0.5 * delta * h2 * k1
            + 0.25 * 1j * gammaG * h2 * k1
            - 1j * delta * h2 * w
            + 0.5 * gammaG * h2 * w
            + 0.5 * h2 * k1 * w
            - 1j * h2 * w**2
            )
    D = (-1j * delta - 0.5 * gammaH + 1j * w) * (
            1j * g2 * (0.5 * 1j * g2 * k1 + g2 * w)
            + (-0.5*k2 + 1j *w) * (
                g1**2
                - 0.5*1j * delta * k1
                + 0.25 * gammaG * k1
                - delta * w
                - 1j * 0.5 * gammaG * w
                - 1j * 0.5 * k1 * w
                - w**2
                )
            )
    return np.abs(A / (B + C + D))**2

def S21(w, onlyone=None):
    return S12(w, -p, onlyone)

