import numpy as np

kappa1 = 100.
kappa2 = 100.
gamma1 = 0.05
gamma2 = 0.05
C1 = 400.
C2 = C1 
G11 = np.sqrt(kappa1 * gamma1 * C1 / 4.0)
G21 = np.sqrt(kappa2 * gamma1 * C1 / 4.0)
G12 = np.sqrt(kappa1 * gamma2 * C2 / 4.0)
G22 = np.sqrt(kappa2 * gamma2 * C2 / 4.0)
factor = np.sqrt(2.*C1-1.)
delta1 = gamma1/2.0 * factor
delta2 = -gamma2/2.0 * factor

def over_chi(om, width, delta=0):
    return (width/2.0 - 1j*(om + delta))

def direct_path(om, phi):
    inv_matrix = np.matrix([
        [over_chi(om, gamma1, delta1), 1j * G21],
        [1j * G21, over_chi(om, kappa2)]
            ])
    return inv_matrix

def other_path(om, phi):
    invmat1 = np.diagflat([1j* G11 * np.exp(-1j*phi), 1j * G22])
    invmat2 = np.matrix([
        [over_chi(om, gamma2, delta2), -1j * G12],
        [-1j * G12, over_chi(om, kappa1)]
            ])
    invmat3 = np.diagflat([1j* G11 * np.exp(1j*phi), 1j * G22])
    inv_factor = (over_chi(om, gamma2, delta2)*over_chi(om, kappa1) 
            + np.abs(G12)**2)
    inv_matrix = - np.dot(invmat1, np.dot(invmat2, invmat3)) / inv_factor
    return inv_matrix

def other_mod_path(om, phi):
    other = other_path(om,phi)
    inv_matrix = other + np.diagflat(
            [over_chi(om, gamma1, delta1), over_chi(om, kappa2)])
    return inv_matrix

def noise_transm(inv_matrix):
    M = np.linalg.inv(inv_matrix)
    trans = M[0,1] 
    return np.abs(trans)*2


