import matplotlib
import noise_calibration as nc
import os, sys
lib_path = os.path.abspath(os.path.join('..', 'modules'))
sys.path.append(lib_path)
import graph
import getdata as gd

matplotlib.rcParams['font.size'] = 24

color_data = 'xkcd:maroon'

data_forward = 'data/170511_fsw_trace'
BG_forward = 'data/133434_fsw_trace'
data_backward = 'data/170100_fsw_trace'
BG_backward = 'data/134023_fsw_trace'

fisi = (1.9, 1.2)

for datafile, BGfile, name in zip(
        (data_forward, data_backward), (BG_forward, BG_backward), 
        ('forward', 'backward')):

    freqs =  nc.get_freqs(datafile)
    if name == 'forward':
        noise = nc.normnoise_bright(datafile, nc.measure_background(BGfile))
        ylab = '${N}_\mathrm{fw}$ (quanta/(s Hz))'
    else:
        noise = nc.normnoise_dark(datafile, nc.measure_background(BGfile))
        ylab = '${N}_\mathrm{bw}$ (quanta/(s Hz))'

    freqs = 1e6*(freqs - freqs.mean())
    graph.graph(
            [freqs], [noise],
            'data_{}.pdf'.format(name),
            xlab = 'Frequency detuning (kHz)',
            ylab = ylab,
            small=True,
            yrange=[1, 100],
            xrange=[-150, 150],
            fisi=fisi,
            colors=[color_data],
            logy=True,
            )

